| Cantera 3.0.0

Loading...
Searching...
No Matches
Public Member Functions | Protected Attributes | List of all members
ShomatePoly2 Class Reference
Thermodynamic Properties » Species Reference-State Thermodynamic Properties

The Shomate polynomial parameterization for two temperature ranges for one species. More...

`#include <ShomatePoly.h>`

Inheritance diagram for ShomatePoly2:
[legend]

## Detailed Description

The Shomate polynomial parameterization for two temperature ranges for one species.

Seven coefficients \( (A,\dots,G) \) are used to represent \( c_p^0(T) \), \( h^0(T) \), and \( s^0(T) \) as polynomials in the temperature, \( T \), in one temperature region:

\[ \tilde{c}_p^0(T) = A + B t + C t^2 + D t^3 + \frac{E}{t^2} \]

\[ \tilde{h}^0(T) = A t + \frac{B t^2}{2} + \frac{C t^3}{3} + \frac{D t^4}{4} - \frac{E}{t} + F. \]

\[ \tilde{s}^0(T) = A\ln t + B t + \frac{C t^2}{2} + \frac{D t^3}{3} - \frac{E}{2t^2} + G. \]

In the above expressions, the thermodynamic polynomials are expressed in dimensional units, but the temperature, \( t \), is divided by 1000. The following dimensions are assumed in the above expressions:

- \( \tilde{c}_p^0(T) \) = Heat Capacity (J/gmol*K)
- \( \tilde{h}^0(T) \) = standard Enthalpy (kJ/gmol)
- \( \tilde{s}^0(T) \)= standard Entropy (J/gmol*K)
- \( t \)= temperature (K) / 1000.

For more information about Shomate polynomials, see the NIST website, http://webbook.nist.gov/

Before being used within Cantera, the dimensions must be adjusted to those used by Cantera (for example, Joules and kmol).

This function uses two temperature regions, each with a Shomate polynomial representation to represent the thermo functions. There are 15 coefficients, therefore, in this representation. The first coefficient is the midrange temperature.

Definition at line 232 of file ShomatePoly.h.

## Public Member Functions
| ShomatePoly2 (double tlow, double thigh, double pref, const double *coeffs)
| Constructor with all input data.
void | setMinTemp (double Tmin) override
| Set the minimum temperature at which the thermo parameterization is valid.
void | setMaxTemp (double Tmax) override
| Set the maximum temperature at which the thermo parameterization is valid.
void | setRefPressure (double Pref) override
| Set the reference pressure [Pa].
void | setParameters (double Tmid, const vector< double > &low, const vector< double > &high)
int | reportType () const override
| Returns an integer representing the type of parameterization.
size_t | temperaturePolySize () const override
| Number of terms in the temperature polynomial for this parameterization.
void | updateTemperaturePoly (double T, double *T_poly) const override
| Given the temperature T, compute the terms of the temperature polynomial T_poly.
void | updateProperties (const double *tt, double *cp_R, double *h_RT, double *s_R) const override
| Update the properties for this species, given a temperature polynomial.
void | updatePropertiesTemp (const double temp, double *cp_R, double *h_RT, double *s_R) const override
| Compute the reference-state property of one species.
size_t | nCoeffs () const override
| This utility function returns the number of coefficients for a given type of species parameterization.
void | reportParameters (size_t &n, int &type, double &tlow, double &thigh, double &pref, double *const coeffs) const override
| This utility function returns the type of parameterization and all of the parameters for the species.
void | getParameters (AnyMap &thermo) const override
| Store the parameters of the species thermo object such that an identical species thermo object could be reconstructed using the newSpeciesThermo() function.
double | reportHf298 (double *const h298=nullptr) const override
| Report the 298 K Heat of Formation of the standard state of one species (J kmol-1)
void | modifyOneHf298 (const size_t k, const double Hf298New) override
| Modify the value of the 298 K Heat of Formation of one species in the phase (J kmol-1)
void | resetHf298 () override
| Restore the original heat of formation for this species.
Public Member Functions inherited from SpeciesThermoInterpType
| SpeciesThermoInterpType (double tlow, double thigh, double pref)
| SpeciesThermoInterpType (const SpeciesThermoInterpType &b)=delete
SpeciesThermoInterpType & | operator= (const SpeciesThermoInterpType &b)=delete
virtual double | minTemp () const
| Returns the minimum temperature that the thermo parameterization is valid.
virtual double | maxTemp () const
| Returns the maximum temperature that the thermo parameterization is valid.
virtual double | refPressure () const
| Returns the reference pressure (Pa)
virtual void | validate (const string &name)
| Check for problems with the parameterization, and generate warnings or throw and exception if any are found.
AnyMap | parameters (bool withInput=true) const
| Return the parameters of the species thermo object such that an identical species thermo object could be reconstructed using the newSpeciesThermo() function.
const AnyMap & | input () const
| Access input data associated with the species thermo definition.
AnyMap & | input ()

## Protected Attributes
double | m_midT
| Midrange temperature (kelvin)
ShomatePoly | msp_low
| Shomate polynomial for the low temperature region.
ShomatePoly | msp_high
| Shomate polynomial for the high temperature region.
Protected Attributes inherited from SpeciesThermoInterpType
double | m_lowT = 0.0
| lowest valid temperature
double | m_highT = 0.0
| Highest valid temperature.
double | m_Pref = 0.0
| Reference state pressure.
AnyMap | m_input

## Additional Inherited Members

## Constructor & Destructor Documentation

## ◆ ShomatePoly2() [1/2]

ShomatePoly2 | ( |  | ) |
| inline

Definition at line 235 of file ShomatePoly.h.

## ◆ ShomatePoly2() [2/2]

ShomatePoly2 | ( | double | tlow,
|  | double | thigh,
|  | double | pref,
|  | const double * | coeffs
| ) |  |
| inline

Constructor with all input data.

Parameters

  tlow | Minimum temperature
  thigh | Maximum temperature
  pref | reference pressure (Pa).
  coeffs | Vector of coefficients used to set the parameters for the standard state. [Tmid, 7 low-T coeffs, 7 high-T coeffs]

Definition at line 245 of file ShomatePoly.h.

## Member Function Documentation

## ◆ setMinTemp()

void setMinTemp | ( | double | Tmin | ) |
| inline override virtual

Set the minimum temperature at which the thermo parameterization is valid.

Reimplemented from SpeciesThermoInterpType.

Definition at line 253 of file ShomatePoly.h.

## ◆ setMaxTemp()

void setMaxTemp | ( | double | Tmax | ) |
| inline override virtual

Set the maximum temperature at which the thermo parameterization is valid.

Reimplemented from SpeciesThermoInterpType.

Definition at line 258 of file ShomatePoly.h.

## ◆ setRefPressure()

void setRefPressure | ( | double | Pref | ) |
| inline override virtual

Set the reference pressure [Pa].

Reimplemented from SpeciesThermoInterpType.

Definition at line 263 of file ShomatePoly.h.

## ◆ setParameters()

void setParameters | ( | double | Tmid,
|  | const vector< double > & | low,
|  | const vector< double > & | high
| ) |  |
| inline

Parameters

  Tmid | Temperature [K] at the boundary between the low and high temperature polynomials
  low | Vector of 7 coefficients for the low temperature polynomial
  high | Vector of 7 coefficients for the high temperature polynomial

Definition at line 275 of file ShomatePoly.h.

## ◆ reportType()

int reportType | ( |  | ) | const
| inline override virtual

Returns an integer representing the type of parameterization.

Reimplemented from SpeciesThermoInterpType.

Definition at line 283 of file ShomatePoly.h.

## ◆ temperaturePolySize()

size_t temperaturePolySize | ( |  | ) | const
| inline override virtual

Number of terms in the temperature polynomial for this parameterization.

Reimplemented from SpeciesThermoInterpType.

Definition at line 287 of file ShomatePoly.h.

## ◆ updateTemperaturePoly()

void updateTemperaturePoly | ( | double | T,
|  | double * | T_poly
| ) |  | const
| inline override virtual

Given the temperature T, compute the terms of the temperature polynomial T_poly.

Reimplemented from SpeciesThermoInterpType.

Definition at line 289 of file ShomatePoly.h.

## ◆ updateProperties()

void updateProperties | ( | const double * | tt,
|  | double * | cp_R,
|  | double * | h_RT,
|  | double * | s_R
| ) |  | const
| inline override virtual

Update the properties for this species, given a temperature polynomial.

This method is called with a pointer to an array containing the functions of temperature needed by this parameterization, and three pointers to arrays where the computed property values should be written. This method updates only one value in each array.

The form and length of the Temperature Polynomial may vary depending on the parameterization.

Parameters

  tt | vector of evaluated temperature functions
  cp_R | Vector of Dimensionless heat capacities. (length m_kk).
  h_RT | Vector of Dimensionless enthalpies. (length m_kk).
  s_R | Vector of Dimensionless entropies. (length m_kk).

Form of the temperature polynomial:

- `t` is T/1000.
- `t[0] = t`
- `t[1] = t*t`
- `t[2] = t[1]*t`
- `t[3] = 1.0/t[1]`
- `t[4] = log(t)`
- `t[5] = 1.0/t;

Reimplemented from SpeciesThermoInterpType.

Definition at line 294 of file ShomatePoly.h.

## ◆ updatePropertiesTemp()

void updatePropertiesTemp | ( | const double | temp,
|  | double * | cp_R,
|  | double * | h_RT,
|  | double * | s_R
| ) |  | const
| inline override virtual

Compute the reference-state property of one species.

Given temperature T in K, this method updates the values of the non- dimensional heat capacity at constant pressure, enthalpy, and entropy, at the reference pressure, of the species.

Parameters

  temp | Temperature (Kelvin)
  cp_R | Vector of Dimensionless heat capacities. (length m_kk).
  h_RT | Vector of Dimensionless enthalpies. (length m_kk).
  s_R | Vector of Dimensionless entropies. (length m_kk).

Reimplemented from SpeciesThermoInterpType.

Definition at line 304 of file ShomatePoly.h.

## ◆ nCoeffs()

size_t nCoeffs | ( |  | ) | const
| inline override virtual

This utility function returns the number of coefficients for a given type of species parameterization.

Reimplemented from SpeciesThermoInterpType.

Definition at line 313 of file ShomatePoly.h.

## ◆ reportParameters()

void reportParameters | ( | size_t & | index,
|  | int & | type,
|  | double & | minTemp,
|  | double & | maxTemp,
|  | double & | refPressure,
|  | double *const | coeffs
| ) |  | const
| inline override virtual

This utility function returns the type of parameterization and all of the parameters for the species.

All parameters are output variables

Parameters

  index | Species index
  type | Integer type of the standard type
  minTemp | output - Minimum temperature
  maxTemp | output - Maximum temperature
  refPressure | output - reference pressure (Pa).
  coeffs | Vector of coefficients used to set the parameters for the standard state.

Reimplemented from SpeciesThermoInterpType.

Definition at line 315 of file ShomatePoly.h.

## ◆ getParameters()

void getParameters | ( | AnyMap & | thermo | ) | const
| inline override virtual

Store the parameters of the species thermo object such that an identical species thermo object could be reconstructed using the newSpeciesThermo() function.

Reimplemented from SpeciesThermoInterpType.

Definition at line 322 of file ShomatePoly.h.

## ◆ reportHf298()

double reportHf298 | ( | double *const | h298 = `nullptr` | ) | const
| inline override virtual

Report the 298 K Heat of Formation of the standard state of one species (J kmol-1)

The 298K Heat of Formation is defined as the enthalpy change to create the standard state of the species from its constituent elements in their standard states at 298 K and 1 bar.

Parameters

  h298 | If this is nonnull, the current value of the Heat of Formation at 298K and 1 bar for species m_speciesIndex is returned in h298[m_speciesIndex].

Returns
  the current value of the Heat of Formation at 298K and 1 bar for species m_speciesIndex.

Reimplemented from SpeciesThermoInterpType.

Definition at line 332 of file ShomatePoly.h.

## ◆ modifyOneHf298()

void modifyOneHf298 | ( | const size_t | k,
|  | const double | Hf298New
| ) |  |
| inline override virtual

Modify the value of the 298 K Heat of Formation of one species in the phase (J kmol-1)

The 298K heat of formation is defined as the enthalpy change to create the standard state of the species from its constituent elements in their standard states at 298 K and 1 bar.

Parameters

  k | Species k
  Hf298New | Specify the new value of the Heat of Formation at 298K and 1 bar

Reimplemented from SpeciesThermoInterpType.

Definition at line 345 of file ShomatePoly.h.

## ◆ resetHf298()

void resetHf298 | ( |  | ) |
| inline override virtual

Restore the original heat of formation for this species.

Resets changes made by modifyOneHf298().

Reimplemented from SpeciesThermoInterpType.

Definition at line 356 of file ShomatePoly.h.

## Member Data Documentation

## ◆ m_midT

double m_midT
| protected

Midrange temperature (kelvin)

Definition at line 363 of file ShomatePoly.h.

## ◆ msp_low

ShomatePoly msp_low
| protected

Shomate polynomial for the low temperature region.

Definition at line 365 of file ShomatePoly.h.

## ◆ msp_high

ShomatePoly msp_high
| protected

Shomate polynomial for the high temperature region.

Definition at line 367 of file ShomatePoly.h.

The documentation for this class was generated from the following file:

- ShomatePoly.h